# This file is a template, and might need editing before it works on your project.
# This example is for testing Django with PostgreSQL.
#
# The test CI/CD variables POSTGRES_DB, POSTGRES_USER and POSTGRES_PASS can be set in the project settings at:
#     Settings --> CI/CD --> Variables
#
# The Django settings in settings.py, used in tests, might look similar to:
#
#  DATABASES = {
#      'default': {
#         'ENGINE': 'django.db.backends.mysql',
#         'NAME': os.environ.get('POSTGRES_DATABASE'),
#        	'USER':  os.environ.get('POSTGRES_USER'),
#        	'PASSWORD': os.environ.get('POSTGRES_PASSWORD'),
#       	'HOST': 'postgresql',
#     	  'PORT': '5432',
#         'CONN_MAX_AGE':60,
#      },
#  }
#
# It is possible to use '--settings' to specify a custom settings file on the command line below or use an environment
# variable to trigger an include on the bottom of your settings.py:
#   if os.environ.get('DJANGO_CONFIG')=='test':
#       from .settings_test import *
#
# It is also possible to hardcode the database name and credentials in the settings.py file and in the .gitlab-ci.yml file.
#
# The mysql service needs some variables too. See https://hub.docker.com/_/mysql for possible mysql env variables
# Note that when using a service in GitLab CI/CD that needs environment variables to run, only variables defined in
# .gitlab-ci.yml are passed to the service and variables defined in the GitLab UI are not.
# https://gitlab.com/gitlab-org/gitlab/-/issues/30178

variables:
  # DJANGO_CONFIG: "test"
  DB_NAME: yanko_db
  DB_USER: yankoadmin
  DB_PASSWORD: qwertY@12345
  DB_HOST: postgres
  DB_PORT: 5432
  TEST_DB_HOST: 0.0.0.0

  #  POSTGRES_HOST_AUTH_METHOD: trust
  # Configure postgres service (https://hub.docker.com/_/postgres/)
  #
  #
  # When you use the dind service, you must instruct Docker to talk with
  # the daemon started inside of the service. The daemon is available
  # with a network connection instead of the default
  # /var/run/docker.sock socket. Docker 19.03 does this automatically
  # by setting the DOCKER_HOST in
  # https://github.com/docker-library/docker/blob/d45051476babc297257df490d22cbd806f1b11e4/19.03/docker-entrypoint.sh#L23-L29
  #
  # The 'docker' hostname is the alias of the service container as described at
  # https://docs.gitlab.com/ee/ci/services/#accessing-the-services.
  #
  # Specify to Docker where to create the certificates. Docker
  # creates them automatically on boot, and creates
  # `/certs/client` to share between the service and job
  # container, thanks to volume mount from config.toml
  DOCKER_TLS_CERTDIR: "/certs"

default:
  image: docker:24.0.5
  #
  # Pick zero or more services to be used on all builds.
  # Only needed when using a docker container to run your tests in.
  # Check out: https://docs.gitlab.com/ee/ci/services/index.html
  services:
    - docker:24.0.5-dind
  #    - postgres:12.2-alpine
  before_script:
  #  - docker info
  #  - apt -y update
  #  - apt -y install apt-utils
  #  - apt -y install net-tools python3.8 python3-pip postgresql-client-12
  #  - apt -y upgrade
  #
  # This folder is cached between builds
  # http://docs.gitlab.com/ee/ci/yaml/README.html#cache
  cache:
    paths:
      - ~/.cache/pip/


build:
  stage: build
  services:
    - docker:24.0.5-dind
    - postgres:12.2-alpine
  image: docker:24.0.5 #ubuntu:20.04
  variables:
    # Configure postgres service (https://hub.docker.com/_/postgres/)
    POSTGRES_DB: $DB_NAME   # MUST be set
    POSTGRES_USER: $DB_USER # MUST be set
    POSTGRES_PASSWORD: $DB_PASSWORD # MUST be set
  script:
    - apk update
    - apk upgrade
    #- apk add apt-utils
    #- apk add net-tools
    #- apk add postgresql-client-12
    #- export PGPASSWORD=$DB_PASSWORD # MUST be set
    #- psql -h "$DB_HOST_PROD" -U "$POSTGRES_USER" -d "$POSTGRES_DB" -c "SELECT 'OK' AS status;"
    #    - docker run my-docker-image /script/to/run/tests
    - docker build --build-arg DB_HOST=$DB_HOST -t $CI_REGISTRY/$CI_PROJECT_NAME .
    - docker login $CI_REGISTRY -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD
    - docker tag $CI_REGISTRY/$CI_PROJECT_NAME $CI_REGISTRY/trifon/$CI_PROJECT_NAME
    - docker push $CI_REGISTRY/trifon/$CI_PROJECT_NAME


test-db-connection:
  stage: test
  services:
    - postgres:12.2-alpine
  variables:
    # Configure postgres service (https://hub.docker.com/_/postgres/)
    POSTGRES_DB: $DB_NAME   # MUST be set
    POSTGRES_USER: $DB_USER # MUST be set
    POSTGRES_PASSWORD: $DB_PASSWORD # MUST be set
  image: postgres:12.2-alpine
  script:
    # official way to provide password to psql: http://www.postgresql.org/docs/9.3/static/libpq-envars.html
    - export PGPASSWORD=$DB_PASSWORD # MUST be set
    #    - echo PGPASSWORD is "$PGPASSWORD"
    #    - echo DB_USER is "$DB_USER"
    #    - echo DB_NAME is "$DB_NAME"
    #    - echo POSTGRES_DB is "$POSTGRES_DB"
    #   - echo POSTGRES_USER is "$POSTGRES_USER"
    - psql -h "$DB_HOST" -U "$DB_USER" -d "$DB_NAME" -c "SELECT 'OK' AS status;"



##Added by Yanko
run-unit-and-integration-tests:
  #                 Cannot set Environment for Selenium.   99% coverage             #
  stage: test
  services:
    - docker:24.0.5-dind
  image: docker:24.0.5 #ubuntu:20.04
  before_script:
    - apk update
    - apk upgrade
  script:
    - docker network create testnetwork
    - docker run -d --name postgres -p 5432:5432 -h $DB_HOST --network testnetwork -e POSTGRES_PASSWORD=$DB_PASSWORD -e POSTGRES_USER=$DB_USER -e POSTGRES_DB=$DB_NAME postgres:12.2-alpine
    - docker build --build-arg DB_HOST=$DB_HOST -t image-for-tests:t01 .
    - docker run -d --name container_for_tests --network testnetwork image-for-tests:t01 sleep infinity
    - docker exec -e DB_HOST=$DB_HOST container_for_tests python manage.py migrate                              # Test cant run without migrations
    - docker exec -e DB_HOST=$DB_HOST container_for_tests coverage run manage.py test       # Running Tests
    - docker exec -e DB_HOST=$DB_HOST container_for_tests coverage report --omit=tests/*    # Export report
    #    - docker rm container_for_tests -f
    #    - docker rm postgres -f
    #    - docker rmi image-for-tests:t01 -f
    #    - docker network rm testnetwork
  needs:
    - [ "test-db-connection", "build" ]





#Added by Yanko
#run-unit-and-integration-tests:
#                 Not working properly. Cannot set Environment for Selenium.                #
#  stage: test
#  services:
#    - postgres:12.2-alpine
#  image: python:3.8
#  variables:
#    POSTGRES_DB: $DB_NAME
#    POSTGRES_USER: $DB_USER
#    POSTGRES_PASSWORD: $DB_PASSWORD
#  before_script:
#    - apt-get update
#    #- apt-get install -y chromium-browser
#    #- export WEBDRIVER="/usr/bin/chromedriver"
#  script:
#    - pip install -r requirements.txt  # Install Python dependencies
#    - python manage.py makemigrations
#    - python manage.py migrate
#    - coverage run manage.py test
#    - coverage report --omit=tests/*
#    - coverage report > test_report.txt --omit=tests/*
#  needs:
#    - [ "test-db-connection", "build" ]



deploy-image-job:
  stage: deploy
  image:
    name: bitnami/kubectl:1.24
    entrypoint: [ '' ]
  script:
    - echo "Deploying to Kubernetes cluster!"
    - kubectl config get-contexts
    - kubectl config use-context $KUBE_CONTEXT
    - kubectl get pods
    # Deploy Redis
    - kubectl apply -f k8s/redis/config-map.yml
    - kubectl apply -f k8s/redis/deployment.yml
    - kubectl apply -f k8s/redis/service.yml
    #    - kubectl apply -f k8s/jwt-secret.yml
    #    - kubectl apply -f k8s/postgresql.yml
    - kubectl apply -f k8s/deployment.yml
    - kubectl apply -f k8s/service.yml
    - kubectl apply -f k8s/ingress.yml
    - kubectl rollout restart deployment djangoyanko #@Trifon - important to get new image
    - kubectl get pods
  needs: # Added by Yanko
    - [ "run-unit-and-integration-tests" ]
